﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using PropertyGridDemo.Objects;
using PropertyGridDemo.Properties;

namespace PropertyGridDemo.Controls
{
    public partial class ShapeDialogBox : Form
    {
        private Shape _shape = null;

        public ShapeDialogBox()
        {
            InitializeComponent();
            Text = Resources.TITLE_SHAPEEDITOR;
            labelWidth.Text = Resources.LABEL_WIDTH;
            labelHeight.Text = Resources.LABEL_HEIGHT;
            labelColor.Text = Resources.LABEL_COLOR;
            buttonOK.Text = Resources.BTN_OK;
            buttonCancel.Text = Resources.BTN_CANCEL;
        }
        public Shape SelectedObject
        {
            get
            {
                return _shape;
            }
            set
            {
                _shape = value;
                if (_shape != null)
                {
                    updownWidth.Value = _shape.ShapeSize.Width;
                    updownHeight.Value = _shape.ShapeSize.Height;
                    panelColor.BackColor = _shape.ShapeColor;
                    buttonSelColor.Enabled = true;
                }
                else
                {
                    updownWidth.Value = 0;
                    updownWidth.Enabled = false;
                    updownHeight.Value = 0;
                    updownHeight.Enabled = false;
                    panelColor.BackColor = SystemColors.Control;
                    buttonSelColor.Enabled = false;
                }
            }
        }

        private void updownWidth_ValueChanged(object sender, EventArgs e)
        {
            if (_shape != null)
            {
                _shape.ShapeSize = new Size((int)updownWidth.Value, _shape.ShapeSize.Height);
            }
        }

        private void updownHeight_ValueChanged(object sender, EventArgs e)
        {
            if (_shape != null)
            {
                _shape.ShapeSize = new Size(_shape.ShapeSize.Width, (int)updownWidth.Value);
            }
        }

        private void buttonSelColor_Click(object sender, EventArgs e)
        {
            if (_shape != null)
            {
                colorDlg.Color = _shape.ShapeColor;
                if (colorDlg.ShowDialog() == DialogResult.OK)
                {
                    _shape.ShapeColor = colorDlg.Color;
                    panelColor.BackColor = colorDlg.Color;
                }
            }
        }
    }
}
