﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;
using System.Windows.Forms;
using System.Windows.Forms.Design;
using PropertyGridDemo.Objects;

namespace PropertyGridDemo.Controls
{
    public class ShapeListBoxEditor : ListBoxEditor
    {
        public ShapeListBoxEditor(object selection, IWindowsFormsEditorService edsvc) 
            : base(selection, edsvc)
        {
            DrawMode = DrawMode.OwnerDrawFixed;
        }

        protected override void OnDrawItem(DrawItemEventArgs e)
        {
            base.OnDrawItem(e);
            if (e.Index >= 0)
            {
                Shape shape = Items[e.Index] as Shape;
                if (shape != null)
                {
                    Rectangle rect = e.Bounds;
                    rect.Inflate(-2, -2);
                    shape.ShapeSize = new Size(rect.Height, rect.Height);
                    shape.DrawShape(e.Graphics, rect.X, rect.Y);
                    Font f = new Font("Arial", 9);
                    e.Graphics.DrawString(shape.ToString(), f, SystemBrushes.WindowText, rect.Height + 4, rect.Top + ((rect.Height - e.Graphics.MeasureString(shape.ToString(), f).Height) / 2));
                    f.Dispose();
                }
            }
        }
    }
}
