﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Drawing;
using System.Drawing.Design;
using System.Text;
using System.Threading.Tasks;
using System.ComponentModel;
using System.ComponentModel.Design;
using PropertyGridDemo.Controls;
using PropertyGridDemo.Objects;

namespace PropertyGridDemo
{
    public class DemoObject
    {
        public enum ValueEnum
        {
            One, Two, Three
        }
        public DemoObject()
        {
            CollectionProperty = new List<string>();
            CollectionProperty.Add("This is the first value");
            CollectionProperty.Add("This is the second value");
            CollectionProperty.Add("This is the third value");
            CollectionProperty.Add("...");
            CollectionProperty.Add("And so on");
            ReadOnlyProperty = "This is not editable";
        }
        [Browsable(false)]
        public string NonBrowsable { get; set; }
        [CategoryGlobal("CAT_SIMPLEPROPERTIES")]
        [DisplayNameGlobal("NAME_STRINGPROPERTY")]
        [DescriptionGlobal("DESC_STRINGPROPERTY")]
        public string StringProperty { get; set; }
        [CategoryGlobal("CAT_SIMPLEPROPERTIES")]
        [DisplayNameGlobal("NAME_INTPROPERTY")]
        [DescriptionGlobal("DESC_INTPROPERTY")]
        [DefaultValue(0)]
        public int IntProperty { get; set; }
        [CategoryGlobal("CAT_SIMPLEPROPERTIES")]
        [DisplayNameGlobal("NAME_COLORPROPERTY")]
        [DescriptionGlobal("DESC_COLORPROPERTY")]
        public Color ColorProperty { get; set; }
        [CategoryGlobal("CAT_SIMPLEPROPERTIES")]
        [DisplayNameGlobal("NAME_READONLYPROPERTY")]
        [DescriptionGlobal("DESC_READONLYPROPERTY")]
        [ReadOnly(true)]
        public string ReadOnlyProperty { get; set; }
        [CategoryGlobal("CAT_COMPOSITEPROPERTIES")]
        [DisplayNameGlobal("NAME_SIZEPROPERTY")]
        [DescriptionGlobal("DESC_SIZEPROPERTY")]
        [RefreshProperties(RefreshProperties.All)]
        public Size SizeProperty { get; set; }
        [CategoryGlobal("CAT_COMPOSITEPROPERTIES")]
        [DisplayNameGlobal("NAME_COLLECTIONPROPERTY")]
        [DescriptionGlobal("DESC_COLLECTIONPROPERTY")]
        public List<string> CollectionProperty { get; set; }
        [CategoryGlobal("CAT_COMPOSITEPROPERTIES")]
        [DisplayNameGlobal("NAME_ENUMPROPERTY")]
        [DescriptionGlobal("DESC_ENUMPROPERTY")]
        [DefaultValue(ValueEnum.One)]
        public ValueEnum EnumProperty { get; set; }
        [CategoryGlobal("CAT_CUSTOMEDITORS")]
        [DisplayNameGlobal("NAME_SHAPETYPEPROPERTY")]
        [DescriptionGlobal("DESC_SHAPETYPEPROPERTY")]
        [RefreshProperties(RefreshProperties.All)]
        [Editor(typeof(ShapeTypeEditor), typeof(UITypeEditor))]
        public Shape ShapeTypeProperty { get; set; }
        [CategoryGlobal("CAT_CUSTOMEDITORS")]
        [DisplayNameGlobal("NAME_SHAPEPROPERTY")]
        [DescriptionGlobal("DESC_SHAPEPROPERTY")]
        [Editor(typeof(ShapeEditor), typeof(UITypeEditor))]
        public Shape ShapeProperty { get; set; }
    }
}
